
/*
 *	command.c - Commands which have nothing to do with mail...
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <time.h>

#include "defines.h"
#include "command.h"
#include "config.h"
#include "mailcmd.h"
#include "mbox.h"
#include "utils.h"
#include "quit.h"

struct cmd Mailcmds[] = {
	{ "?",		do_help		},
	{ "Help",	do_help		},
	{ "Info",	do_help		},
	{ "List",	do_list		},
	{ "Kill",	do_kill		},
	{ "Unkill",	do_unkill	},
	{ "Read",	do_read		},
	{ "Verbose",	do_read		},
	{ "Send",	do_send		},
	{ "SReply",	do_send		},
	{ "Name",	do_name		},
	{ "STatus",	do_status	},
	{ "Exit",	do_exit		},
	{ "Quit",	do_quit		},
	{ "Bye",	do_bye		},
	{ NULL,		NULL		}
};

void cmdlisthlp()
{
  printf("?                -  mostra esta lista de comandos\n");
  printf("                 -  shows this command list\n");
  printf("                 -  ukaze tento seznam povelu\n");
  printf("Help <cmd>       -  mostra ajuda pra o comando especificado\n");
  printf("                 -  shows help for specified command\n");
  printf("                 -  ukaze podrobne help k vybranemu povelu\n");
  printf("Info             -  mostra informacao sobre a programa etc.\n");
  printf("                 -  shows information about program etc.\n");
  printf("                 -  ukaze informace o programu a j.\n");
  printf("List             -  mostra lista das msgs na sua caixa\n");
  printf("                 -  shows msg list of your mailbox\n");
  printf("                 -  ukaze seznam zprav v Tve schrance\n");
  printf("Kill <msg No.>   -  apaga msgm de numero especificado\n");
  printf("                 -  deletes msg with specified number\n");
  printf("                 -  vymaze zpravu zadaneho cisla\n");
  printf("Unkill <msg No.> -  restaura apagada msg de especif.numero\n");
  printf("                 -  restores deleted msg of specif.number\n");
  printf("                 -  obnovi vymazanou zpravu zadaneho cisla\n");
  printf("Read <msg No>    -  mostra toda msgm de especif.numero\n");
  printf("                 -  shows comlete msg of specif.number\n");
  printf("                 -  ukaze zpravu zadaneho cisla\n");
  printf("Send <endereco>  -  comeca producir o email para enviar\n");
  printf("                 -  starts to make email\n");
  printf("                 -  zapocne vytvoreni emailu k odeslani\n");
  printf("SReply <msg No.> -  comeca producir resposta no email No.\n");
  printf("                 -  starts make a reply for email No.\n");
  printf("                 -  zapocne odpoved na email No.\n");
  printf("Name             -  armacena o seu 'msg-cabeza' nome\n");
  printf("                 -  saves your msg headar name\n");
  printf("                 -  ulozi Tve jmeno pro hlavicku mailu\n");
  printf("STatus           -  mostra estado da sua caixa\n");
  printf("                 -  shows the state of your mailbox\n");
  printf("                 -  ukaze obsah Tve schranky\n");
  printf("Exit             -  saie da programa aceitando mudancas na caixa\n");
  printf("                 -  quits program accepting changes in mailbox\n");
  printf("                 -  vystup z programu se zmenami ve schrance\n");
  printf("Bye              -  saie da programa sem aceitar mudancas na caixa\n");
  printf("                 -  quits program non-accepting changes in mailbox\n");
  printf("                 -  vystup z programu beze zmen ve schrance\n");
  printf("Quit             -  iqual como Bye\n");
  printf("                 -  same as Bye\n");
  printf("                 -  totez jako Bye\n");
}

int do_status(int argc, char **argv)
{
	printf("Messages: %i\n", messages);
	return 0;

}

int do_name(int argc, char **argv)
{
	char name[32];
	
	getname(name);
	
	if (strlen(name) == 0)
		printf("Name not changed. ");
	else {	/* Okay, save it */
		strcpy(fullname, name);
	}
	
	printf("You're now known as %s.\n", fullname);
	
	return 0;
}

int do_help(int argc, char **argv)
{
	FILE *fp;
	char fname[80], line[256];
/*	struct cmd *cmdp;
	int i = 0;  */

	if (*argv[0] == '?') {				/* "?"		*/
		printf("All commands (portugues/english/cesky):\n");
		cmdlisthlp();
	/*	for (cmdp = Mailcmds; cmdp->name != NULL; cmdp++) {
			printf("%s%s", i ? ", " : "", cmdp->name);
			if (++i == 10) {
				printf("\n");
				i = 0;	
			}
		}
		if (i) printf("\n");  */
		{
		printf("\n");
		}
		return 0;
	}
	strcpy(fname, DATA_AXMAIL_HELP_DIR);
	if (*argv[0] == 'i') {				/* "info"	*/
		strcat(fname, "info.hlp");
		/* printf("%s - %s\n", VERSION, COPYRIGHT); */
	        printf("%s\n", VERSION);
		printf("%s", LICENSE);
	} else if (argc == 1) {				/* "help"	*/
		strcat(fname, "help.hlp");
	} else {					/* "help <cmd>"	*/
		if (strchr(argv[1], '/') == NULL) {
			strlwr(argv[1]);
			strcat(fname, argv[1]);
			strcat(fname, ".hlp");
		}
	}
	if ((fp = fopen(fname, "r")) == NULL) {
		if (*argv[0] != 'i')
			printf("No help for command %s.\n", argv[1] ? argv[1] : "help");
		return 0;
	}
	if (*argv[0] != 'i')
		printf("Help for command %s:\n", argv[1] ? argv[1] : "help");
	while (fgets(line, 256, fp) != NULL) {
		printf("%s", line);
		}
	fclose(fp);
	return 0;
}

int do_quit(int argc, char **argv)
{
	quit(0, 0);
	return 0;
}


int do_bye(int argc, char **argv)
{
	quit(0, 0);
	return 0;
}



int do_exit(int argc, char **argv)
{
	quit(1, 0);
	return 0;
}

